/*===============================================================*/
/*
* Parallel Recursive Spectral Bisection -
* Based on the sequential version provided by Horst Simon
* -ravi
*/
/*===============================================================*/
#include "parti.h"

#include <stdio.h>
#include "hum.h"
#include "time.h"

/*
#define DEBUG
#include <util.h>
#define malloc(size) NEWN(char, size)
#define free(ptr) DISPOSE(ptr)
*/

/*===============================================================*/
/* called by genfid 
 * calls lanczos 
 */
/*===============================================================*/


genord(ttable, xadj_ind, xadj, adj, neqns,nref,  fied, teqns)
TTABLE *ttable;
int *xadj_ind, *xadj, *adj;
int neqns, teqns, nref;
double *fied;
{
   
   SCHED *adjsched, *junk;
   int i;
   int *mask;
   double *diag, *u;
   int degmax;
   int n_off_proc;
   int n_off_proc1;
   int *adj_loc;
   double eval;
   void lanczo();
   void fudge();
   
#ifdef  DEBUG2
    if (PARTI_mynode ==0)
    printf("entered genord \n");
#endif

   diag   = (double *) malloc(neqns* sizeof(double));
   for(i=0; i<neqns; i++) diag[i] = 0.0;

#ifdef TIME
  schedst = dclock();
#endif

   /* build schedule to get off procesor elements */
   /* using xadj and adj (csr) indirections       */

   adj_loc  = (int *) malloc(sizeof(int)*nref);
/*
   mlocalize(ttable, &adjsched, &junk, adj, adj_loc, nref, &n_off_proc, &n_off_proc1, neqns, 0, NULL, 1);
*/
   localize(ttable, &adjsched,  adj, adj_loc, nref, &n_off_proc,  neqns , 1);
#ifdef TIME
    schedtt +=  dclock() - schedst;
#endif

   u = (double *) malloc((neqns+n_off_proc)*sizeof(double));
   for(i=0; i<neqns+n_off_proc; i++) u[i] = 0.0;


   for(i=0; i<neqns; i++) {
     fied[i] = 1.0;
   }

   opk(adjsched, xadj, adj_loc, diag, fied, u, neqns, n_off_proc);
   
   degmax = 0.0;
   for(i=0; i<neqns; i++) {
     degmax = MAX(degmax, -u[i]);
   }

   /* set diagonal elements to degree */   
   for(i=0; i<neqns; i++) {
     diag[i] = -u[i];
   }
  
 
#ifdef TIME
    lanzst = dclock();
#endif
   lanczo(adjsched, xadj_ind, xadj,  adj_loc, neqns, n_off_proc, 
			diag, &eval, fied, u, teqns);
#ifdef TIME
    lanztt += dclock() - lanzst;
#endif
#ifdef FIEDLER
/*
   if (PARTI_mynode == 0) 
   printf("FIEDLER VALUE %f \n", eval); PARTI_gsync();
*/
#endif

   fudge(fied, neqns);

   free(u); 
   free(adj_loc); free(diag);

   free_sched(adjsched);

}
/*===============================================================*/


build_schedule(ttable, sched, xadj, adj, neqns, nref, adj_loc, noffproc)
TTABLE *ttable;
SCHED **sched;
int *xadj, *adj, **adj_loc;
int neqns, *noffproc;
{

   SCHED *lsched;
   int i, j, ccount;
   int  *loc_ref;
   int off_proc;

/*
   for(ccount=0,i=0; i<neqns; i++) { 
     for(j=xadj[i]; j<xadj[i+1]; j++) { 
       ccount++; 
     } 
   } 
*/

   loc_ref  = (int *) malloc(sizeof(int)*nref);

   localize(ttable, &lsched, adj, loc_ref, nref, &off_proc, neqns, 1); 

   *sched    = lsched;
   *adj_loc  = loc_ref;
   *noffproc = off_proc;
   
}
/*===============================================================*/
